# EKFCh_cond Class Reference

Extended Kalman filter with unknown parameters in `IM`. More...

`#include <ekf_templ.h>`

Inheritance diagram for EKFCh_cond:

[legend]
Collaboration diagram for EKFCh_cond:

[legend]

List of all members.

## Public Member Functions
| EKFCh_cond (RV rx, RV ry, RV ru, RV rC)
| Default constructor.
void | condition (const vec &val)
| Substitute `val` for `rvc`.
| EKFCh_cond (RV rx, RV ry, RV ru, RV rC)
| Default constructor.
void | condition (const vec &val)
| Substitute `val` for `rvc`.
void | set_parameters (diffbifn *pfxu, diffbifn *phxu, const chmat Q0, const chmat R0)
| Set nonlinear functions for mean values and covariance matrices.
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const chmat &R0, const chmat &Q0)
| Set parameters with check of relevance.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_est (const vec &mu0, const chmat &P0)
| Set estimate values, used e.g. in initialization.
const epdf & | _epdf () const
| access function
const enorm< chmat > * | _e () const
| Returns a pointer to the epdf representing posterior density on parameters. Use with care!
mat & | __K ()
| access function
vec | _dP ()
| access function
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | predictor (const RV &rv) const
| Constructs a predictive density (marginal density on data).
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
virtual BM * | _copy_ (bool changerv=false)
const RV & | _rvc () const
| access function
## Protected Attributes
diffbifn * | pfxu
| Internal Model f(x,u).
diffbifn * | phxu
| Observation Model h(x,u).
mat | preA
| pre array (triangular matrix)
mat | postA
| post array (triangular matrix)
RV | rvy
| Indetifier of output rv.
RV | rvu
| Indetifier of exogeneous rv.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
chmat | Q
| Matrix Q in square-root form.
chmat | R
| Matrix R in square-root form.
enorm< chmat > | est
| posterior density on $x_t$
enorm< chmat > | fy
| preditive density on $y_t$
mat | _K
| placeholder for Kalman gain
vec & | _yp
| cache of fy.mu
chmat & | _Ry
| cache of fy.R
vec & | _mu
| cache of est.mu
chmat & | _P
| cache of est.R
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
RV | rvc
| Identificator of the conditioning variable.

## Detailed Description

Extended Kalman filter with unknown parameters in `IM`.

Extended Kalman filter with unknown `Q`.

## Member Function Documentation

virtual double BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in ARX, MixEF, and multiBM.

Referenced by BM::logpred_m().

virtual BM* BM::_copy_ | ( | bool | changerv = `false` | ) | `[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*); return Tmp; }

Reimplemented in ARX, and BMEF.

The documentation for this class was generated from the following files:

- work/git/mixpp/bdm/estim/ekf_templ.h
- work/git/mixpp/pmsm/mpf_u_weight.cpp